#include <stdio.h>
#include <stdlib.h>

#include <glib-object.h>
#include <glib/gprintf.h>

#include "controller.h"

/**
 * SECTION: Controller
 * @title: Controller
 *
 * Missing Documentation about a controller.
 **/

/* static functions, boilerplate code */
static void ui_controller_init (UiController *object);
static void ui_controller_class_init (UiControllerClass * controller_class);
static GObject *ui_controller_constructor (GType gtype,
    guint n_properties, GObjectConstructParam *properties);
static void ui_controller_finalize (GObject *object);
static void ui_controller_dispose (GObject *object);
static void ui_controller_get_property (GObject *object,
    guint property_id, GValue *value, GParamSpec *param_spec);
static void ui_controller_set_property (GObject *object, guint property_id,
    const GValue *value, GParamSpec *param_spec);

/* static functions, local */

/* static functions, interface implementation */
static gboolean ui_controller_connect_with_main_loop_impl (UiController *controller,
    GMainLoop *main_loop, GMainContext *main_context, GError **error);
static gboolean ui_controller_configure_impl (UiController *controller,
    const gchar *filename, GError **error);
static gboolean ui_controller_register_with_dbus_impl (UiController *controller,
    const gchar *object_path, DBusGConnection * bus, GError **error);

/* static objects */
static GObjectClass *parent_class = NULL;
static guint signals[UI_CONTROLLER_SIGNAL_COUNT] = { 0 };

/* private structure */
typedef struct _UiControllerPrivate UiControllerPrivate;

/**
 * UiControllerPrivate:
 * @id: A string, with no particular use, just to get properties working.
 **/
struct _UiControllerPrivate
{
  gchar *id;
};

#define UI_CONTROLLER_GET_PRIVATE(obj) \
  (G_TYPE_INSTANCE_GET_PRIVATE ((obj), UI_TYPE_CONTROLLER, \
                                UiControllerPrivate))

/**
 * ui_controller_get_type:
 * @returns: a #GType
 *
 * boilerplate function, defines the type returned by UI_TYPE_CONTROLLER
 **/
GType
ui_controller_get_type (void)
{
  static GType ui_controller_type = 0;
  if (G_UNLIKELY (ui_controller_type == 0))
  {
    static const GTypeInfo info = {
      sizeof (UiControllerClass), /* class_size */
      (GBaseInitFunc) NULL,     /* base_init */
      (GBaseFinalizeFunc) NULL, /* base_finalize */
      (GClassInitFunc) ui_controller_class_init,  /* class_init */
      (GClassFinalizeFunc) NULL,  /* class_finalize */
      NULL,                     /* class_data */
      sizeof (UiController),    /* instance_size */
      0,                        /* n_preallocs */
      (GInstanceInitFunc) ui_controller_init, /* instance_init */
      NULL                      /* value_table */
    };

    ui_controller_type = g_type_register_static (G_TYPE_OBJECT, /* parent type */
        "UiController",         /* name of the new type */
        &info,                  /* GTypeInfo for this type */
        0                       /* Flags (e.g abstract) */
        );
  }
  return ui_controller_type;
}

/**
 * ui_controller_init:
 * @ui_controller: A #UiController
 *
 * boilerplate function, initializes the #UiController
 **/
static void
ui_controller_init (UiController *ui_controller)
{
  UiControllerPrivate *priv;

  priv = UI_CONTROLLER_GET_PRIVATE (ui_controller);

  priv->id = g_strdup ("");
}

/**
 * ui_controller_class_init:
 * @ui_controller_class: A #UiControllerClass
 *
 * boilerplate function, initializes the #UiControllerClass
 **/
static void
ui_controller_class_init (UiControllerClass * ui_controller_class)
{
  GObjectClass *object_class = G_OBJECT_CLASS (ui_controller_class);

  /* add private section */
  g_type_class_add_private (ui_controller_class, sizeof (UiControllerPrivate));

  /* define the parent class */
  parent_class = g_type_class_peek_parent (ui_controller_class);

  /* assign boilerplate functions */
  object_class->dispose = ui_controller_dispose;
  object_class->finalize = ui_controller_finalize;
  object_class->constructor = ui_controller_constructor;
  object_class->get_property = ui_controller_get_property;
  object_class->set_property = ui_controller_set_property;

  /* assign interface functions */
  ui_controller_class->configure = ui_controller_configure_impl;
  ui_controller_class->register_with_dbus = ui_controller_register_with_dbus_impl;
  ui_controller_class->connect_with_main_loop = ui_controller_connect_with_main_loop_impl;

  /* create properties */
  g_object_class_install_property (object_class,
      UI_CONTROLLER_PROPERTY_ID,
      g_param_spec_string ("id", "Id", "Id", NULL, G_PARAM_READWRITE));

  /* create signals */
  signals[UI_CONTROLLER_SIGNAL_CONFIGURED] = g_signal_new ("configured",
      G_OBJECT_CLASS_TYPE
      (ui_controller_class),
      G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

/**
 * ui_controller_dispose:
 * @object:
 *
 * boilerplate function.
 **/
void
ui_controller_dispose (GObject *object)
{
  UiController *self = UI_CONTROLLER (object);
  UiControllerPrivate *priv = UI_CONTROLLER_GET_PRIVATE (self);

  /* release any references held by the object here */
  g_free (priv->id);

  if (G_OBJECT_CLASS (parent_class)->dispose)
    G_OBJECT_CLASS (parent_class)->dispose (object);
}

/**
 * ui_controller_finalize:
 * @object:
 *
 * boilerplate function.
 **/
void
ui_controller_finalize (GObject *object)
{
  if (G_OBJECT_CLASS (parent_class)->finalize)
    G_OBJECT_CLASS (parent_class)->finalize (object);
}

/**
 * ui_controller_constructor:
 * @gtype:
 * @n_properties:
 * @properties:
 *
 * boilerplate function.
 **/
static GObject *
ui_controller_constructor (GType gtype, guint n_properties,
    GObjectConstructParam *properties)
{

  GObjectClass *object_class = G_OBJECT_CLASS (parent_class);
  GObject *object = object_class->constructor (gtype, n_properties, properties);

  /* TODO Update object state / constructor properties */

  return object;
}

/**
 * ui_controller_get_property:
 * @object:
 * @property_id:
 * @value:
 * @param_spec:
 *
 * boilerplate function.
 **/
static void
ui_controller_get_property (GObject *object, guint property_id,
    GValue *value, GParamSpec *param_spec)
{
  g_return_if_fail (UI_IS_CONTROLLER (object));

  UiController *controller = UI_CONTROLLER (object);
  UiControllerPrivate *priv = UI_CONTROLLER_GET_PRIVATE (controller);

  switch (property_id)
  {
    case UI_CONTROLLER_PROPERTY_ID:
      g_value_set_string (value, priv->id);
      break;
    default:
      G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, param_spec);
      break;
  }
}

/**
 * ui_controller_set_property:
 * @object:
 * @property_id:
 * @value:
 * @param_spec:
 *
 * boilerplate function.
 **/
static void
ui_controller_set_property (GObject *object, guint property_id,
    const GValue *value, GParamSpec *param_spec)
{
  g_return_if_fail (UI_IS_CONTROLLER (object));

  UiController *controller = UI_CONTROLLER (object);
  UiControllerPrivate *priv = UI_CONTROLLER_GET_PRIVATE (controller);

  switch (property_id)
  {
    case UI_CONTROLLER_PROPERTY_ID:
      g_free (priv->id);
      priv->id = g_value_dup_string (value);
      break;
    default:
      G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, param_spec);
      break;
  };
}

/**
 * ui_controller_new:
 * @id:
 * @returns: A new UiController
 *
 * The user is expected to delete the controller with ui_controller_free when
 * it is no longer needed.
 **/
UiController *
ui_controller_new (gchar *id)
{
  g_return_val_if_fail (id != NULL, NULL);

  UiController *controller = g_object_new (UI_TYPE_CONTROLLER,
      "id", id,
      NULL);

  return controller;
}

/**
 * ui_controller_free:
 * @data:
 *
 * This function decreases the reference cound of the controller by one, and if
 * no other objects holds a reference to that controller, it is deallocated.
 *
 * This function implements GDestroyNotify */
void
ui_controller_free (gpointer data)
{
  g_return_if_fail (UI_IS_CONTROLLER (data));
  UiController *controller = UI_CONTROLLER (data);
  g_object_unref (controller);
}

/**
 * ui_controller_configure:
 * @controller:
 * @filename:
 * @error:
 * @returns: TRUE if the configuration was successful, FALSE otherwise.
 *
 * This function forwards the call to an implementation.
 **/
gboolean
ui_controller_configure (UiController *controller, const gchar *filename, GError **error)
{
  if (!UI_IS_CONTROLLER (controller))
  {
    GTimeVal timestamp;
    g_get_current_time (&timestamp);
    g_set_error (error,
        UI_CONTROLLER_ERROR,
        UI_CONTROLLER_ERROR_PROGRAMMING,
        "%s<#>%s<#>%s",
        g_time_val_to_iso8601 (&timestamp),
        "ui_controller_configure", "invalid \'controller\' argument");
    return FALSE;
  }
  GError *err = NULL;
  gboolean res
      = UI_CONTROLLER_GET_CLASS (controller)->configure (controller, filename, &err);
  if (err != NULL)
  {
    g_propagate_error (error, err);
    return FALSE;
  }
  return res;
}

/**
 * ui_controller_register_with_dbus:
 * @controller:
 * @object_path:
 * @bus:
 * @error:
 *
 * This function forwards the call to an implementation.
 **/
gboolean
ui_controller_register_with_dbus (UiController *controller,
    const gchar *object_path, DBusGConnection * bus, GError **error)
{
  if (!UI_IS_CONTROLLER (controller))
  {
    GTimeVal timestamp;
    g_get_current_time (&timestamp);
    g_set_error (error,
        UI_CONTROLLER_ERROR,
        UI_CONTROLLER_ERROR_PROGRAMMING,
        "%s<#>%s<#>%s",
        g_time_val_to_iso8601 (&timestamp),
        "ui_controller_register_with_dbus", "invalid \'controller\' argument");
    return FALSE;
  }
  GError *err = NULL;
  gboolean res =
      UI_CONTROLLER_GET_CLASS (controller)->register_with_dbus (controller, object_path,
      bus, &err);
  if (err != NULL)
  {
    g_propagate_error (error, err);
    return FALSE;
  }
  return res;
}

/**
 * ui_controller_connect_with_main_loop
 * @controller:
 * @main_loop:
 * @main_context:
 * @error:
 *
 * This function forwards the call to an implementation.
 **/
gboolean
ui_controller_connect_with_main_loop (UiController *controller,
    GMainLoop *main_loop, GMainContext *main_context, GError **error)
{
  if (!UI_IS_CONTROLLER (controller))
  {
    GTimeVal timestamp;
    g_get_current_time (&timestamp);
    g_set_error (error,
        UI_CONTROLLER_ERROR,
        UI_CONTROLLER_ERROR_PROGRAMMING,
        "%s<#>%s<#>%s",
        g_time_val_to_iso8601 (&timestamp),
        "ui_controller_register_with_dbus", "invalid \'controller\' argument");
    return FALSE;
  }
  GError *err = NULL;
  gboolean res =
      UI_CONTROLLER_GET_CLASS (controller)->connect_with_main_loop (controller, main_loop,
      main_context, &err);
  if (err != NULL)
  {
    g_propagate_error (error, err);
    return FALSE;
  }
  return res;
}

/**
 * ui_controller_get_id:
 * @controller:
 * @returns: A pointer to the controller's id.
 **/
const gchar *
ui_controller_get_id (UiController *controller)
{
  g_return_val_if_fail (UI_IS_CONTROLLER (controller), NULL);
  UiControllerPrivate *priv = UI_CONTROLLER_GET_PRIVATE (controller);
  return priv->id;
}

GQuark
ui_controller_error_quark ()
{
  return g_quark_from_string ("UI_CONTROLLER_ERROR");
}

/**
 * ui_controller_configure_impl:
 * @controller:
 * @filename:
 * @error:
 * @returns: TRUE if the operation was successful, FALSE otherwise
 **/
static gboolean
ui_controller_configure_impl (UiController *controller, const gchar *filename,
    GError **error)
{
  if (!UI_IS_CONTROLLER (controller))
  {
    GTimeVal timestamp;
    g_get_current_time (&timestamp);
    g_set_error (error,
        UI_CONTROLLER_ERROR,
        UI_CONTROLLER_ERROR_PROGRAMMING,
        "%s<#>%s<#>%s",
        g_time_val_to_iso8601 (&timestamp),
        "ui_controller_configure_impl", "invalid \'controller\' argument");
    return FALSE;
  }
  GTimeVal timestamp;
  g_get_current_time (&timestamp);
  g_set_error (error,
      UI_CONTROLLER_ERROR,
      UI_CONTROLLER_ERROR_NOT_IMPLEMENTED,
      "%s<#>%s<#>%s",
      g_time_val_to_iso8601 (&timestamp),
      "ui_controller_configure_impl", "no implementation available");
  return FALSE;
}

/**
 * ui_controller_register_with_dbus_impl:
 * @controller:
 * @object_path:
 * @bus:
 * @error:
 * @returns: TRUE if the action was successful, FALSE otherwise.
 *
 * This default implementation systematically returns FALSE, and sets the error
 * to UI_CONTROLLER_ERROR_NOT_IMPLEMENTED.
 **/
static gboolean
ui_controller_register_with_dbus_impl (UiController *controller,
    const gchar *object_path, DBusGConnection * bus, GError **error)
{
  if (!UI_IS_CONTROLLER (controller))
  {
    GTimeVal timestamp;
    g_get_current_time (&timestamp);
    g_set_error (error,
        UI_CONTROLLER_ERROR,
        UI_CONTROLLER_ERROR_PROGRAMMING,
        "%s<#>%s<#>%s",
        g_time_val_to_iso8601 (&timestamp),
        "ui_controller_register_with_dbus_impl", "invalid \'controller\' argument");
    return FALSE;
  }
  GTimeVal timestamp;
  g_get_current_time (&timestamp);
  g_set_error (error,
      UI_CONTROLLER_ERROR,
      UI_CONTROLLER_ERROR_NOT_IMPLEMENTED,
      "%s<#>%s<#>%s",
      g_time_val_to_iso8601 (&timestamp),
      "ui_controller_register_with_dbus_impl", "no implementation available");
  return FALSE;
}

/**
 * ui_controller_connect_with_main_loop_impl:
 * @controller:
 * @main_loop:
 * @main_context:
 * @error:
 * @returns: TRUE if the action was successful, FALSE otherwise
 *
 * This default implementation systematically returns FALSE and sets the error
 * to UI_CONTROLLER_ERROR_NOT_IMPLEMENTED
 **/
static gboolean
ui_controller_connect_with_main_loop_impl (UiController *controller,
    GMainLoop *main_loop, GMainContext *main_context, GError **error)
{
  if (!UI_IS_CONTROLLER (controller))
  {
    GTimeVal timestamp;
    g_get_current_time (&timestamp);
    g_set_error (error,
        UI_CONTROLLER_ERROR,
        UI_CONTROLLER_ERROR_PROGRAMMING,
        "%s<#>%s<#>%s",
        g_time_val_to_iso8601 (&timestamp),
        "ui_controller_connect_with_main_loop_impl", "invalid \'controller\' argument");
    return FALSE;
  }
  GTimeVal timestamp;
  g_get_current_time (&timestamp);
  g_set_error (error,
      UI_CONTROLLER_ERROR,
      UI_CONTROLLER_ERROR_NOT_IMPLEMENTED,
      "%s<#>%s<#>%s",
      g_time_val_to_iso8601 (&timestamp),
      "ui_controller_connect_with_main_loop_impl", "no implementation available");
  return FALSE;
}
